% oprations sur les complexes
% Manuel Luque
% manuel.luque27@gmail.com
% 23/05/2020
/Imul{% produit de 2 nombres complexes
% z1*z2 => z
6 dict begin
/z2 exch def
/z1 exch def
/x1 z1 0 get def
/y1 z1 1 get def
/x2 z2 0 get def
/y2 z2 1 get def
[
x1 x2 mul y1 y2 mul sub
x1 y2 mul x2 y1 mul add
]
end
} def
/Iabs{% module d'un complexe
3 dict begin
/z exch def
/x z 0 get def
/y z 1 get def
x dup mul y dup mul add sqrt
end
} def
/Iadd { % addition de 2 complexes
% z1*z2 => z
6 dict begin
/z2 exch def
/z1 exch def
/x1 z1 0 get def
/y1 z1 1 get def
/x2 z2 0 get def
/y2 z2 1 get def
[x1 x2 add  y1 y2 add]
end
} def
/Irmul {% multiplier un complexe par un rel
2 dict begin
/z exch def
/r exch def
[z {r mul} forall]
end
} def
/ReZ { % partie relle
 0 get
} def
/ImZ { % partie imaginaire
 1 get
} def
%en complexes
/ChebyshevT {
3 dict begin
/T0 [1 0] def
/z exch def
/n exch def
/T1 z def
n 0 eq n 1 eq or {
n 0 eq {T0} if
n 1 eq {T1} if}{
n 1 sub {
/T2 2 z Irmul T1 Imul -1 T0 Irmul Iadd def
/T0 T1 def
/T1 T2 def
} repeat
T2}
ifelse
end
} def
